# JUnitTileLimit Mod
# By: Jeckel
#

from CvPythonExtensions import *

import CvAlertManager
import CvConfigParser

###################################################
# globals
gc = CyGlobalContext()
#localText = CyTranslator()

alert = CvAlertManager.CvAlertManager()

###################################################
class CvJUnitTileLimitUtils:
	def __init__(self):
                #self.config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                self.iLastPlayer = -1
                self.iLastUnitId = -1
                self.bLastReturn = False
                self.tLastPlot = (-1, -1)
                self.dPlotXYs = {}

	################################################################################################

        def isEnabled(self):
		# Load the JLimitedEra Mod Config INI file containing all of the configuration information
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
        	bEnabled = config.getboolean("General Options", "JUnitTileLimit Features Enabled", True)
        	if (not bEnabled):
                        return False
                return True

        def isCityNoLimit(self):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                return config.getboolean("General Options", "City Tiles Have No Unit Limit", False)

        def isCityTrainNeedFreeSpace(self):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                return config.getboolean("General Options", "City Needs Free Space To Train Units", True)

        def isCityBuildingCumulative(self):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                return config.getboolean("General Options", "City Building Modifiers Are Cumulative", True)

	################################################################################################

        def isIgnoreLandUnits(self):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                return config.getboolean("General Options", "Ignore Land Units", True)

        def isIgnoreSeaUnits(self):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                return config.getboolean("General Options", "Ignore Sea Units", True)

        def isIgnoreAirUnits(self):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                return config.getboolean("General Options", "Ignore Air Units", True)

	################################################################################################

        def getBuildingMod(self, sBuildingType):
                configCityBuilding = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - City Buildings.ini")
                if (not configCityBuilding.has_section("City Building Modifiers")):
                        return 0
                elif (not configCityBuilding.has_option("City Building Modifiers", sBuildingType)):
                        return 0
                else:
                        return configCityBuilding.getint("City Building Modifiers", sBuildingType, 0)

	################################################################################################

        def getBonusMod(self, sBonusType):
                configBonus = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Bonuses.ini")
                if (not configBonus.has_section("Bonus Modifiers")):
                        return 0
                elif (not configBonus.has_option("Bonus Modifiers", sBonusType)):
                        return 0
                else:
                        return configBonus.getint("Bonus Modifiers", sBonusType, 0)

	################################################################################################

        def getFeatureMod(self, sFeatureType):
                configFeature = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Features.ini")
                if (not configFeature.has_section("Feature Modifiers")):
                        return 0
                elif (not configFeature.has_option("Feature Modifiers", sFeatureType)):
                        return 0
                else:
                        return configFeature.getint("Feature Modifiers", sFeatureType, 0)

	################################################################################################

        def getImprovementMod(self, sImprovementType):
                configImprovement = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Improvements.ini")
                if (not configImprovement.has_section("Improvement Modifiers")):
                        return 0
                elif (not configImprovement.has_option("Improvement Modifiers", sImprovementType)):
                        return 0
                else:
                        return configImprovement.getint("Improvement Modifiers", sImprovementType, 0)

	################################################################################################

        def getTerrainMod(self, sTerrainType):
                configTerrain = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Terrain.ini")
                if (not configTerrain.has_section("Terrain Modifiers")):
                        return 0
                elif (not configTerrain.has_option("Terrain Modifiers", sTerrainType)):
                        return 0
                else:
                        return configTerrain.getint("Terrain Modifiers", sTerrainType, 0)

	################################################################################################

        def getUnitClassTypeSize(self, sUnitClassType):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                bEnableUnitSizeMods = config.getboolean("General Options", "Enable Unit Size Modifiers", True)
                iDefaultUnitSize = config.getint("General Options", "Default Unit Size", 1)
                if (bEnableUnitSizeMods):
                        sizes = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Unit Sizes.ini")
                        if (not sizes.has_section("Unit Size Modifiers")):
                                return iDefaultUnitSize
                        if (not sizes.has_option("Unit Size Modifiers", sUnitClassType)):
                                return iDefaultUnitSize
                        else:
                                iSize = sizes.getint("Unit Size Modifiers", sUnitClassType, 0)
                                return iSize
                return iDefaultUnitSize

	################################################################################################

        def getUnitSize(self, pUnit):
                # This could prob be better if given a list of pUnits and
                # returns either a list of sizes or a sum of all sizes
                # so that it will only have to call the config files a
                # single time
                # Not sure if it would be practically faster but may be
                # worth it if the mod lags at all
                # UPDATE: Seems to be some barly noticable lag building
                # up because of this method
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                bEnableUnitSizeMods = config.getboolean("General Options", "Enable Unit Size Modifiers", True)
                iDefaultUnitSize = config.getint("General Options", "Default Unit Size", 1)
                if (bEnableUnitSizeMods):
                        sizes = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Unit Sizes.ini")
                        if (not sizes.has_section("Unit Size Modifiers")):
                                #alert.debug(0, "iDefaultUnitSize", iDefaultUnitSize)
                                return iDefaultUnitSize
                        sUnitClass = gc.getUnitClassInfo(pUnit.getUnitClassType()).getType()
                        if (not sizes.has_option("Unit Size Modifiers", sUnitClass)):
                                #alert.debug(0, "iDefaultUnitSize", iDefaultUnitSize)
                                return iDefaultUnitSize
                        else:
                                iSize = sizes.getint("Unit Size Modifiers", sUnitClass, 0)
                                #alert.debug(0, "iSize", iSize)
                                return iSize
                #alert.debug(0, "iDefaultUnitSize", iDefaultUnitSize)
                return iDefaultUnitSize

        def getPlotSizeCount(self, pPlot):
                iCountSize = 0
                #alert.debug(0, "iCountSizeA", iCountSize)
                for iLoopUnit in range(pPlot.getNumUnits()):
                        pLoopUnit = pPlot.getUnit(iLoopUnit)
                        if (pLoopUnit.isCargo()):
                                continue
                        iLoopSize = self.getUnitSize(pLoopUnit)
                        #alert.debug(0, "iLoopSize", iLoopSize)
                        iCountSize += iLoopSize
                #alert.debug(0, "iCountSizeB", iCountSize)
                return iCountSize

        def getEnableOption(self, sOption, bDefault):
                config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                if (not config.has_section("General Options")):
                        return bDefault
                if (not config.has_option("General Options", sOption)):
                        return bDefault
                return config.getboolean("General Options", sOption, bDefault)

        def getMaxUnits(self, pPlot, pPlayer):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
                iMaxUnits = self.getBaseLimit(pPlot)
                #alert.debug(0, "iMaxUnits-1", iMaxUnits)
                if (pPlot.isCity()):
                        #alert.debug(0, "iMaxUnits-2", iMaxUnits)
                        bEnableCityMods = config.getboolean("General Options", "Enable City Limit Modifiers", True)
                        if (bEnableCityMods):
                                iMaxUnits += self.getModsCity(pPlot.getPlotCity())
                                #alert.debug(0, "iMaxUnits-2-A", iMaxUnits)
                        bEnableCityCultureLevelMods = config.getboolean("General Options", "Enable City Culture Level Limit Modifiers", True)
                        if (bEnableCityCultureLevelMods):
                                iMaxUnits += self.getModsCityCultureLevel(pPlot.getPlotCity())
                                #alert.debug(0, "iMaxUnits-2-B", iMaxUnits)
                        bEnableCityBuildingMods = config.getboolean("General Options", "Enable City Building Limit Modifiers", True)
                        if (bEnableCityBuildingMods):
                                iMaxUnits += self.getModsCityBuilding(pPlot.getPlotCity())
                                #alert.debug(0, "iMaxUnits-2-C", iMaxUnits)
                bEnableBonusMods = config.getboolean("General Options", "Enable Bonus Limit Modifiers", True)
                if (bEnableBonusMods):
                        iMaxUnits += self.getModsBonus(pPlot, pPlayer)
                        #alert.debug(0, "iMaxUnits-3", iMaxUnits)
                bEnableTerrainMods = config.getboolean("General Options", "Enable Terrain Limit Modifiers", True)
                if (bEnableTerrainMods):
                        iMaxUnits += self.getModsTerrain(pPlot)
                        #alert.debug(0, "iMaxUnits-4", iMaxUnits)
                bEnableFeatureMods = config.getboolean("General Options", "Enable Feature Limit Modifiers", True)
                if (bEnableFeatureMods):
                        iMaxUnits += self.getModsFeature(pPlot)
                        #alert.debug(0, "iMaxUnits-5", iMaxUnits)
                bEnableImprovementMods = config.getboolean("General Options", "Enable Improvement Limit Modifiers", True)
                if (bEnableImprovementMods):
                        iMaxUnits += self.getModsImprovement(pPlot)
                        #alert.debug(0, "iMaxUnits-6", iMaxUnits)
                if (iMaxUnits < 0):
                        return 0
                return iMaxUnits

        def getBaseLimit(self, pPlot):
		config = CvConfigParser.CvConfigParser("JUnitTileLimit Mod Config.ini")
		if (pPlot.isWater()):
                        iMaxUnits = config.getint("General Options", "Default Max Units Per Water Tile", 6)
                else:
                        iMaxUnits = config.getint("General Options", "Default Max Units Per Land Tile", 10)
                if (iMaxUnits < 0):
                        return 0
                return iMaxUnits

        def getModsCity(self, pCity):
                if (pCity == None) or (pCity.isNone()):
                        return 0
                configCity = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Cities.ini")
                #alert.debug(0, "configCity", configCity)
                if (configCity.has_section("General Options")):
                        iCityBonus = configCity.getint("General Options", "City Tile Bonus", 0)
                        #alert.debug(0, "iCityBonus", iCityBonus)
                        return iCityBonus
                return 0

        def getModsCityCultureLevel(self, pCity):
                if (pCity == None) or (pCity.isNone()):
                        return 0
                configCity = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - City Culture Levels.ini")
                #alert.debug(0, "configCity", configCity)
                if (configCity.has_section("Culture Level Modifiers")):
                        iCultureLevel = pCity.getCultureLevel()
                        if (iCultureLevel > -1):
                                sCultureLevel = gc.getCultureLevelInfo(iCultureLevel).getType()
                                #alert.debug(0, "sCultureLevel", sCultureLevel)
                                if (configCity.has_option("Culture Level Modifiers", sCultureLevel)):
                                        iCityBonus = configCity.getint("Culture Level Modifiers", sCultureLevel, 0)
                                        return iCityBonus

        def getModsCityBuilding(self, pCity):
                if (pCity == None) or (pCity.isNone()):
                        return 0
                configCityBuilding = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - City Buildings.ini")
                #alert.debug(0, "configCityBuilding", configCityBuilding)
                iCount = 0
                if (configCityBuilding.has_section("City Building Modifiers")):
                        #pCity = pPlot.getPlotCity()
                        # Check for any buildings in the city that effect the unit limit
                        for sLoopType in configCityBuilding.options("City Building Modifiers"):
                                # Remember to convert to upper case as all string
                                # values gotten from the config.ini file are
                                # automagically converted to all lower case
                                sLoopType = sLoopType.upper()
                                iLoopType = gc.getInfoTypeForString(sLoopType)
                                iCountType = pCity.getNumRealBuilding(iLoopType)
                                if (iCountType <= 0):
                                        continue
                                elif (iCountType == 1) or (not self.isCityBuildingCumulative()):
                                        iLoopMod = configCityBuilding.getint("City Building Modifiers", sLoopType, 0)
                                        iCount += iLoopMod
                                else:
                                        iLoopMod = configCityBuilding.getint("City Building Modifiers", sLoopType, 0)
                                        iCount += iLoopMod * iCountType
                return iCount

        def getModsTerrain(self, pPlot):
                if (pPlot == None) or (pPlot.isNone()):
                        return 0
                iMaxUnitsMod = 0
                configTerrain = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Terrain.ini")
                #alert.debug(0, "configTerrain", configTerrain)
                if (configTerrain.has_section("Terrain Modifiers")):
                        iTerrain = pPlot.getTerrainType()
                        if (iTerrain > -1):
                                sTerrain = gc.getTerrainInfo(iTerrain).getType()
                                #alert.debug(0, "sTerrain", sTerrain)
                                if (configTerrain.has_option("Terrain Modifiers", sTerrain)):
                                        iMaxUnitsMod += configTerrain.getint("Terrain Modifiers", sTerrain, 0)
                                        #return iMaxUnitsMod
                if (pPlot.isHills()):
                        sTerrain = "TERRAIN_HILL"
                        #alert.debug(0, "sTerrain", sTerrain)
                        if (configTerrain.has_option("Terrain Modifiers", sTerrain)):
                                iMaxUnitsMod += configTerrain.getint("Terrain Modifiers", sTerrain, 0)
                return iMaxUnitsMod

        def getModsBonus(self, pPlot, pPlayer):
                if (pPlot == None) or (pPlot.isNone()):
                        return 0
                configBonus = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Bonuses.ini")
                #alert.debug(0, "configBonus", configBonus)
                if (configBonus.has_section("Bonus Modifiers")):
                        iBonus = pPlot.getBonusType(pPlayer.getTeam())
                        if (iBonus > -1):
                                sBonus = gc.getBonusInfo(iBonus).getType()
                                #alert.debug(0, "sBonus", sBonus)
                                if (configBonus.has_option("Bonus Modifiers", sBonus)):
                                        iMaxUnitsMod = configBonus.getint("Bonus Modifiers", sBonus, 0)
                                        return iMaxUnitsMod
                return 0

        def getModsFeature(self, pPlot):
                if (pPlot == None) or (pPlot.isNone()):
                        return 0
                configFeature = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Features.ini")
                #alert.debug(0, "configFeature", configFeature)
                if (configFeature.has_section("Feature Modifiers")):
                        iFeature = pPlot.getFeatureType()
                        if (iFeature > -1):
                                sFeature = gc.getFeatureInfo(iFeature).getType()
                                #alert.debug(0, "sFeature", sFeature)
                                if (configFeature.has_option("Feature Modifiers", sFeature)):
                                        iMaxUnitsMod = configFeature.getint("Feature Modifiers", sFeature, 0)
                                        return iMaxUnitsMod
                return 0

        def getModsImprovement(self, pPlot):
                if (pPlot == None) or (pPlot.isNone()):
                        return 0
                configImprovement = CvConfigParser.CvConfigParser("Modifier Config Files/Modifier Config - Improvements.ini")
                #alert.debug(0, "configImprovement", configImprovement)
                if (configImprovement.has_section("Improvement Modifiers")):
                        iImprovement = pPlot.getImprovementType()
                        if (iImprovement > -1):
                                sImprovement = gc.getImprovementInfo(iImprovement).getType()
                                if (configImprovement.has_option("Improvement Modifiers", sImprovement)):
                                        iMaxUnitsMod = configImprovement.getint("Improvement Modifiers", sImprovement, 0)
                                        return iMaxUnitsMod
                return 0















